/*
 *  keyboard map
 */

#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

#include	"devtab.h"

enum{
	Qdir,
	Qdata,
};
Dirtab kbmaptab[]={
	"kbmap",	{Qdata, 0},	0,	0600,
};
#define	NKBFILE	sizeof(kbmaptab)/sizeof(kbmaptab[0])

#define	KBLINELEN	(3*NUMSIZE+1)	/* t code val\n */

void
kbmapreset(void)
{
}

void
kbmapinit(void)
{
}

Chan *
kbmapattach(char *spec)
{
	return devattach(L'κ', spec);
}

Chan *
kbmapclone(Chan *c, Chan *nc)
{
	return devclone(c, nc);
}

int
kbmapwalk(Chan *c, char *name)
{
	return devwalk(c, name, kbmaptab, NKBFILE, devgen);
}

void
kbmapstat(Chan *c, char *db)
{
	devstat(c, db, kbmaptab, NKBFILE, devgen);
}

Chan *
kbmapopen(Chan *c, int omode)
{
	return devopen(c, omode, kbmaptab, NKBFILE, devgen);
}

void
kbmapcreate(Chan *c, char *name, int omode, ulong perm)
{
	USED(c, name, omode, perm);
	error(Eperm);
}

void
kbmapremove(Chan *c)
{
	USED(c);
	error(Eperm);
}

void
kbmapwstat(Chan *c, char *dp)
{
	USED(c, dp);
	error(Eperm);
}

void
kbmapclose(Chan *c)
{
	USED(c);
}

long
kbmapread(Chan *c, void *a, long n, ulong offset)
{
	char *bp;
	char tmp[KBLINELEN+1];
	int t, sc;
	Rune r;

	switch(c->qid.path & ~CHDIR){
	case Qdir:
		return devdirread(c, a, n, kbmaptab, NKBFILE, devgen);
	case Qdata:
		if(kbdgetmap(offset/KBLINELEN, &t, &sc, &r)) {
			bp = tmp;
			bp += readnum(0, bp, NUMSIZE, t, NUMSIZE);
			bp += readnum(0, bp, NUMSIZE, sc, NUMSIZE);
			bp += readnum(0, bp, NUMSIZE, r, NUMSIZE);
			*bp++ = '\n';
			*bp = 0;
			n = readstr(offset%KBLINELEN, a, n, tmp);
		} else
			n = 0;
		break;
	default:
		n=0;
		break;
	}
	return n;
}

long
kbmapwrite(Chan *c, void *a, long n, ulong offset)
{
	char line[100], *lp, *b;
	int key, m, l;
	Rune r;

	USED(offset);
	switch(c->qid.path & ~CHDIR){
	case Qdata:
		b = a;
		l = n;
		for(lp = line; --l >= 0;) {
			*lp++  = *b++;
			if(lp[-1] == '\n' || l == 0 || lp == &line[sizeof(line)-1]) {
				*lp = 0;
				if(*line == 0)
					error(Ebadarg);
				m = strtoul(line, &lp, 0);
				key = strtoul(lp, &lp, 0);
				while(*lp == ' ' || *lp == '\t')
					lp++;
				r = 0;
				if(*lp == '\'' && lp[1])
					chartorune(&r, lp+1);
				else if(*lp>='0' && *lp<='9') /* includes 0x... */
					r = strtoul(lp, &lp, 0);
				else
					error(Ebadarg);
				kbdputmap(m, key, r);
				lp = line;
			}
		}
		break;
	default:
		error(Ebadusefd);
	}
	return n;
}
